
var testOutputWavLog=false;//本测试如果不是输出wav格式，就顺带打一份wav的log，录音后执行mp3、wav合并的demo代码可对比音质
var testSampleRate=16000;
var testBitRate=16;

var SendInterval=300;/******
转码发送间隔（实际间隔比这个变量值偏大点，取决于BufferSize），单位毫秒。这个值可以设置很大，但不能设置很低，毕竟转码和传输还是要花费一定时间的，设备性能低下可能还处理不过来。

mp3格式下一般大于500ms就能保证能够正常转码处理，wav大于100ms，剩下的问题就是传输速度了。由于转码操作都是串行的，录制过程中转码生成出来mp3顺序都是能够得到保证，但结束时最后几段数据可能产生顺序问题，需要留意。由于传输通道不一定稳定，后端接收到的顺序可能错乱，因此可以携带编号进行传输，完成后进行一次排序以纠正顺序错乱的问题。

mp3格式在间隔太低的情况下中间的停顿会非常明显，可适当调大间隔以规避此影响，因为mp3编码时首尾出现了填充的静默数据（mp3.js编码器内已尽力消除了这些静默，但还是会有些许的静默停顿）；wav格式没有此问题，测试时可以打开 testOutputWavLog + mp3、wav合并demo 来对比音质。

当出现性能问题时，可能音频编码不过来，将采取丢弃部分帧的策略。
******/

//重置环境，每次开始录音时必须先调用此方法，清理环境
var RealTimeSendTryReset=function(type){
	realTimeSendTryType=type;
	realTimeSendTryTime=0;
};

var realTimeSendTryType;
var realTimeSendTryEncBusy;
var realTimeSendTryTime=0;
var realTimeSendTryNumber;
var transferUploadNumberMax;
var realTimeSendTryChunk;
var realtime_text='';
var realtime_id=0;

//=====实时处理核心函数==========
var RealTimeSendTry=function(buffers,bufferSampleRate,isClose){
	var t1=Date.now();
	if(realTimeSendTryTime==0){
		realTimeSendTryTime=t1;
		realTimeSendTryEncBusy=0;
		realTimeSendTryNumber=0;
		transferUploadNumberMax=0;
		realTimeSendTryChunk=null;
	};
	if(!isClose && t1-realTimeSendTryTime<SendInterval){
		return;//控制缓冲达到指定间隔才进行传输
	};
	realTimeSendTryTime=t1;
	var number=++realTimeSendTryNumber;
	
	var pcm=[],pcmSampleRate=0;
	if(buffers.length>0){
		//借用SampleData函数进行数据的连续处理，采样率转换是顺带的，得到新的pcm数据
		var chunk=Recorder.SampleData(buffers,bufferSampleRate,testSampleRate,realTimeSendTryChunk,{frameType:isClose?"":realTimeSendTryType});
		
		//清理已处理完的缓冲数据，释放内存以支持长时间录音，最后完成录音时不能调用stop，因为数据已经被清掉了
		for(var i=realTimeSendTryChunk?realTimeSendTryChunk.index:0;i<chunk.index;i++){
			buffers[i]=null;
		};
		realTimeSendTryChunk=chunk;//此时的chunk.data就是原始的音频16位pcm数据（小端LE），直接保存即为16位pcm文件、加个wav头即为wav文件、丢给mp3编码器转一下码即为mp3文件
		
		pcm=chunk.data;
		pcmSampleRate=chunk.sampleRate;
	};
	
	//没有新数据，或结束时的数据量太小，不能进行mock转码
	if(pcm.length==0 || isClose&&pcm.length<2000){
		TransferUpload(number,null,0,null,isClose);
		return;
	};
	
	//实时编码队列阻塞处理
	if(!isClose){
		if(realTimeSendTryEncBusy>=2){
			console.log("编码队列阻塞，已丢弃一帧",1);
			return;
		};
	};
	realTimeSendTryEncBusy++;
	
	//通过mock方法实时转码成mp3、wav；16位pcm格式可以不经过此操作，直接发送new Blob([pcm.buffer],{type:"audio/pcm"}) 要8位的就必须转码
	var encStartTime=Date.now();
	var recMock=Recorder({
		type:realTimeSendTryType
		,sampleRate:testSampleRate //采样率
		,bitRate:testBitRate //比特率
	});
	recMock.mock(pcm,pcmSampleRate);
	recMock.stop(function(blob,duration){
		realTimeSendTryEncBusy&&(realTimeSendTryEncBusy--);
		blob.encTime=Date.now()-encStartTime;
		
		//转码好就推入传输
		TransferUpload(number,blob,duration,recMock,isClose);
	},function(msg){
		realTimeSendTryEncBusy&&(realTimeSendTryEncBusy--);
		
		//转码错误？没想到什么时候会产生错误！
		console.log("不应该出现的错误:"+msg,1);
	});
	
	if(testOutputWavLog&&realTimeSendTryType!="wav"){
		//测试输出一份wav，方便对比数据
		var recMock2=Recorder({
			type:"wav"
			,sampleRate:testSampleRate
			,bitRate:16
		});
		recMock2.mock(pcm,pcmSampleRate);
		recMock2.stop(function(blob,duration){
			var logMsg="No."+(number<100?("000"+number).substr(-3):number);
			//console.logAudio(blob,duration,recMock2,logMsg);
		});
	};
};


/**
 * 随机生成字符串
 * @param len 指定生成字符串长度
 */
function getRandomString(len){
    let _charStr = 'abacdefghjklmnopqrstuvwxyzABCDEFGHJKLMNOPQRSTUVWXYZ0123456789',
        min = 0, 
        max = _charStr.length-1, 
        _str = '';                    //定义随机字符串 变量
    //判断是否指定长度，否则默认长度为15
    len = len || 15;
    //循环生成字符串
    for(var i = 0, index; i < len; i++){
        index = (function(randomIndexFunc, i){         
                    return randomIndexFunc(min, max, i, randomIndexFunc);
                })(function(min, max, i, _self){
                    let indexTemp = Math.floor(Math.random()*(max-min+1)+min),
                        numStart = _charStr.length - 10;
                    if(i==0&&indexTemp >=numStart){
                        indexTemp = _self(min, max, i, _self);
                    }
                    return indexTemp ;
                }, i);
        _str += _charStr[index];
    }
    return _str;
}

var user_token=getRandomString(30);

var ws = new WebSocket("wss://www.tulingyun.com/api/asr_streaming");
ws.onmessage = function(e) {
	re_json=JSON.parse(e.data)
	if (re_json['msg']=="识别成功"){
	    if (realtime_id!=re_json['offline_id']){
		    var punc_state=$("input[name='option_punc']:checked").val();
	    	realtime_id=re_json['offline_id']
			if (punc_state==1){
			realtime_text=realtime_text+re_json['offline']
			}
			else{
			realtime_text=re_json['offline']+'<br>'+realtime_text
			}
	        
			}
		if (re_json['mode']=="wakeup"){
		document.getElementById('mode_now_1').innerHTML = "当前模式状态：语音唤醒模式";
		if (re_json['wakeup_txt']!=''){
		    document.getElementById("asr_result").innerHTML='检测到唤醒词：'+re_json['wakeup_txt']
		}
		else{
		    document.getElementById("asr_result").innerHTML='未检测到唤醒词'
		}
		return
		
		}
		if (re_json['mode']=="online"){
		document.getElementById('mode_now_1').innerHTML = "当前模式状态：语音识别模式";
		}
	    if (re_json['online']==''){
		    document.getElementById("asr_result").innerHTML = realtime_text;
		}
		else{
		    var punc_state=$("input[name='option_punc']:checked").val();
			//console.log(punc_state,punc_state==1,punc_state=="1")
			if (punc_state==1){
			document.getElementById("asr_result").innerHTML = realtime_text+re_json['online'];
			}
			else{
			document.getElementById("asr_result").innerHTML = re_json['online']+'<br>'+realtime_text;
			}
		    
		}
	}
	else{
	    document.getElementById('msgbox').innerHTML = "识别失败:"+re_json['msg'];
	}
	
	console.log(e.data);
}
function sendMsg(msg) {
    ws.send(msg);
}
function close_wss(){
    ws.close
}
//=====数据传输函数==========
var TransferUpload=function(number,blobOrNull,duration,blobRec,isClose){
	transferUploadNumberMax=Math.max(transferUploadNumberMax,number);
	if(blobOrNull){
		var blob=blobOrNull;
		var encTime=blob.encTime;
		
		//*********发送方式一：Base64文本发送***************
		var reader=new FileReader();
		reader.onloadend=function(){
			var base64=(/.+;\s*base64\s*,\s*(.+)$/i.exec(reader.result)||[])[1];
			/*
			$.ajax({
	        url:api 
	        ,type:"POST"
	        ,data:{
	            method:"streaming"
                ,token:user_token
	            ,mime:blob.type 
	            ,upfile_b64:base64 
	            
	        }
	        ,success:function(v){
	            //console.log("上传成功",v);
	            //document.getElementById("asr_result").innerHTML += v.result;
				document.getElementById("asr_result").innerHTML = v.result;
	            //document.getElementById('msgbox').innerHTML = "识别完成";
	        }
	        ,error:function(s){
	            console.error("上传失败",s);
	            document.getElementById('msgbox').innerHTML = "识别失败，文件是否过大？";
	        }
	    });
		*/
		    var punc_state=$("input[name='option_punc']:checked").val();
			//var mode_1=$("input[name='mode_option']:checked").val();
			var hotwords=$("#hotwords").val();
			//var wakeup_list=$("#wakeup_list").val();
            //var requestDict={"token":"asr.tulingyun.com","wav":base64,"hotwords":hotwords,"punc":Number(punc_state),"wakeup_mode":Number(mode_1),"wakeup_list":wakeup_list}
		    var requestDict={"token":"asr.tulingyun.com","wav":base64,"hotwords":hotwords,"punc":Number(punc_state)}
            sendMsg(JSON.stringify(requestDict))
			
			//可以实现
			//WebSocket send(base64) ...
			//WebRTC send(base64) ...
			//XMLHttpRequest send(base64) ...
			
			//这里啥也不干
		};
		reader.readAsDataURL(blob);
		//console.log(blob);
		
		
		//*********发送方式二：Blob二进制发送***************
		//可以实现
		//WebSocket send(blob) ...
		//WebRTC send(blob) ...
		//XMLHttpRequest send(blob) ...
		
		
		//****这里仅 console.log一下 意思意思****
		var numberFail=number<transferUploadNumberMax?'<span style="color:red">顺序错乱的数据，如果要求不高可以直接丢弃，或者调大SendInterval试试</span>':"";
		var logMsg="No."+(number<100?("000"+number).substr(-3):number)+numberFail;
		
		//console.logAudio(blob,duration,blobRec,logMsg+"花"+("___"+encTime).substr(-3)+"ms");
		
		if(true && number%100==0){//emmm....
			console.logClear();
		};
	};
	
	if(isClose){
		console.log("No."+(number<100?("000"+number).substr(-3):number)+":已停止传输");
	};
};


//调用录音
var rec;
function recStartMp3(){
	recStart_steam("mp3");
};
function recStartWav(){
	recStart_steam("wav");
};
function recStartPcm(){
	recStart_steam("pcm");
};
function recStart_steam(type){
    var user_token=getRandomString(30);
	if(rec){
		rec.close();
	};
	rec=Recorder({
		type:"unknown"
		,onProcess:function(buffers,powerLevel,bufferDuration,bufferSampleRate){
			//Runtime.Process.apply(null,arguments);
			
			//推入实时处理，因为是unknown格式，buffers和rec.buffers是完全相同的（此时采样率为浏览器采集音频的原始采样率），只需清理buffers就能释放内存，其他格式不一定有此特性。
			RealTimeSendTry(buffers,bufferSampleRate,false);
		}
	});
	
	var t=setTimeout(function(){
		console.log("无法录音：权限请求被忽略（超时假装手动点击了确认对话框）",1);
	},8000);
	
	rec.open(function(){//打开麦克风授权获得相关资源
		clearTimeout(t);
		rec.start();//开始录音
		
		RealTimeSendTryReset(type);//重置环境，开始录音时必须调用一次
	},function(msg,isUserNotAllow){
		clearTimeout(t);
		console.log((isUserNotAllow?"UserNotAllow，":"")+"无法录音:"+msg, 1);
	});
};
function recStop_steam(){
	rec.close();//直接close掉即可，这个例子不需要获得最终的音频文件
	
	RealTimeSendTry([],0,true);//最后一次发送
};


$("#online_start_record").click(function(event){
    
    document.getElementById("result_div").style.backgroundImage = 'none';

    document.getElementById('upload_asr_file').disabled=true;
	document.getElementById('btn_start_record').disabled=true;
	document.getElementById('btn_end_record').disabled=true;

    document.getElementById('online_start_record').style.display="none"
    document.getElementById('online_end_record').style.display=""

    document.getElementById('msgbox').style.display="";

    document.getElementById('msgbox').innerHTML = "准备录音，若卡在这步请开启麦克风权限";

	if (ws.readyState==1){streaming='接口状态：连接成功';}else{streaming='连接失败请刷新页面';}

	document.getElementById('msgbox').innerHTML = "正在流式识别..."+streaming;
	document.getElementById("asr_result").innerHTML=''
    document.getElementById("spinner_result_id").style.display="none"
	recStartWav();
})

$("#online_end_record").click(function(event){
    recStop_steam();

    document.getElementById('upload_asr_file').disabled=false;
	document.getElementById('btn_start_record').disabled=false;
	document.getElementById('btn_end_record').disabled=false;

    document.getElementById('online_start_record').style.display=""
    document.getElementById('online_end_record').style.display="none"
    
    document.getElementById('msgbox').style.display="none";
    document.getElementById('msgbox').innerHTML = "";
    document.getElementById("spinner_result_id").style.display="none"

	
})





var blob_wav_current;


var rec;
 
var recOpen=function(success){
  rec=Recorder({
      type:"wav",sampleRate:16000,bitRate:16 
      ,onProcess:function(buffers,powerLevel,bufferDuration,bufferSampleRate,newBufferIdx,asyncEnd){
          
          
          
      }
  });

  
  rec.open(function(){
      
      
      
      success&&success();
  },function(msg,isUserNotAllow){
      
      console.log((isUserNotAllow?"UserNotAllow，":"")+"无法录音:"+msg);
  });
};

 
function recStart(){
  rec.start();
};

 
function recStop(){
  rec.stop(function(blob,duration){
      console.log(blob,(window.URL||webkitURL).createObjectURL(blob),"时长:"+duration+"ms");
      rec.close();
      rec=null;
      upload_wav_record(blob)
       
      //var audio=document.createElement("audio");
      //audio.controls=true;
      
      //document.getElementById("wav_pannel").appendChild(audio);
      
      //audio.src=(window.URL||webkitURL).createObjectURL(blob);
      //audio.play();

  },function(msg){
      console.log("录音失败:"+msg);
      rec.close();
      rec=null;
  });
	document.getElementById('msgbox').innerHTML = "";
};


count_id=-1


$("#btn_start_record").click(function(event){
    document.getElementById("result_div").style.backgroundImage = 'none';

    document.getElementById('btn_start_record').style.display="none"
    document.getElementById('btn_end_record').style.display=""
    document.getElementById('msgbox').style.display=""
    document.getElementById('online_start_record').disabled=true;
    document.getElementById('online_end_record').disabled=true;
	recOpen(function(){
	    recStart();
	    //setTimeout(recStop,10000);
        document.getElementById('msgbox').innerHTML = "约1秒后出现倒计时开始录音...";
		countdown=0
        count_id = setInterval(setCountdown, 1000, document.getElementById('msgbox'));
		function setCountdown(targetElement) {
                countdown ++;
                targetElement.innerHTML ="正在录音..."+countdown.toString()
            }
	});
})

$("#btn_end_record").click(function(event){
    document.getElementById('btn_start_record').style.display=""
    document.getElementById('btn_end_record').style.display="none"
	recStop();
    clearInterval(count_id);//停止调用函数
    document.getElementById('msgbox').style.display="none"
    document.getElementById('online_start_record').disabled=false;
    document.getElementById('online_end_record').disabled=false;
})


function upload_wav_record(blob){
	var TestApi="https://www.tulingyun.com/api/asr";
	
	var punc_state=$("input[name='option_punc']:checked").val();
	//console.log(punc_state)
	var api=TestApi;
	
	var hotwords=$("#hotwords").val();
	//console.log(hotword)
	var reader=new FileReader();
    
	reader.onloadend = function() {
	    const reader = new FileReader()
		reader.readAsDataURL(blob)
		reader.onload = function(e) {
            var send_data={
				token:"www.tulingyun.com",
                punc:Number(punc_state),
				hotwords:hotwords,
	            upfile_b64:(/.+;\s*base64\s*,\s*(.+)$/i.exec(reader.result)||[])[1]//这里上传的是base64编码后的图片  
	        }
            document.getElementById("asr_result").innerHTML=''
            document.getElementById("spinner_result_id").style.display=""
            $.ajax({
                url:"https://www.tulingyun.com/api/asr"
                ,type:"POST"
                ,data:JSON.stringify(send_data)
                ,contentType: "application/json"
                ,success:function(v){
                    console.log("上传成功",v);
                    document.getElementById("asr_result").innerHTML = v.result;
                    document.getElementById("result_div").style.backgroundImage = 'none';
                    document.getElementById("spinner_result_id").style.display="none"
                }
                ,error:function(s){
                    console.error("上传失败",s);
                    document.getElementById("spinner_result_id").style.display="none"
                }
            });
            
		}
	}
	reader.readAsDataURL(blob);

}
